var u = Object.defineProperty;
var d = (i, n, t) => n in i ? u(i, n, { enumerable: !0, configurable: !0, writable: !0, value: t }) : i[n] = t;
var o = (i, n, t) => (d(i, typeof n != "symbol" ? n + "" : n, t), t);
import { autoUpdate as l, computePosition as p, shift as b, flip as f, size as m } from "@floating-ui/dom";
import { cancel as r, hello as a, goodbye as c } from "hello-goodbye";
import { focusable as k } from "tabbable";
import { shouldOpenInNewTab as v } from "./inclusive-elements11.js";
class C extends HTMLElement {
  constructor() {
    super();
    o(this, "cleanup");
    o(this, "onButtonClick", (t) => {
      !v(t) && !this.disabled && (this.open = !this.open, t.preventDefault());
    });
    o(this, "onButtonKeyDown", (t) => {
      var e;
      t.key === "ArrowDown" && !this.disabled && (t.preventDefault(), this.open = !0, (e = k(this.content)[0]) == null || e.focus());
    });
    o(this, "onKeyDown", (t) => {
      t.key === "Escape" && this.open && (t.preventDefault(), t.stopPropagation(), this.open = !1, this.button.focus());
    });
    o(this, "onFocusOut", (t) => {
      (!(t.relatedTarget instanceof Node) || !this.contains(t.relatedTarget)) && (this.open = !1);
    });
    o(this, "onContentClick", (t) => {
      t.target instanceof Element && t.target.closest("[role=menuitem], [role=menuitemradio]") && (this.open = !1, this.button.focus());
    });
    const t = document.createElement("template");
    t.innerHTML = `
            <div part="backdrop" hidden style="position: fixed; top: 0; left: 0; right: 0; bottom: 0"></div>
            <slot></slot>
        `, this.attachShadow({ mode: "open" }).appendChild(t.content.cloneNode(!0)), this.backdrop.onclick = () => this.open = !1;
  }
  static get observedAttributes() {
    return ["open"];
  }
  connectedCallback() {
    this.backdrop.hidden = !0, this.content.hidden = !0, this.open = !1, this.button.setAttribute("aria-expanded", "false"), setTimeout(() => {
      this.content.getAttribute("role") === "menu" && this.button.setAttribute("aria-haspopup", "true");
    }), this.button.addEventListener("click", this.onButtonClick), this.button.addEventListener("keydown", this.onButtonKeyDown), this.addEventListener("keydown", this.onKeyDown), this.addEventListener("focusout", this.onFocusOut), this.content.addEventListener("click", this.onContentClick);
  }
  disconnectedCallback() {
    r(this.backdrop), r(this.content), this.button.removeAttribute("aria-expanded"), this.button.removeAttribute("aria-haspopup"), this.button.removeEventListener("click", this.onButtonClick), this.button.removeEventListener("keydown", this.onButtonKeyDown), this.removeEventListener("keydown", this.onKeyDown), this.removeEventListener("focusout", this.onFocusOut), this.content.removeEventListener("click", this.onContentClick);
  }
  get open() {
    return this.hasAttribute("open");
  }
  set open(t) {
    t ? this.setAttribute("open", "") : this.removeAttribute("open");
  }
  get disabled() {
    return this.hasAttribute("disabled");
  }
  attributeChangedCallback(t, e, s) {
    t === "open" && (s !== null ? this.wasOpened() : this.wasClosed());
  }
  wasOpened() {
    if (!this.content.hidden)
      return;
    this.content.hidden = !1, this.content.style.position = "absolute", this.backdrop.hidden = !1, a(this.content), a(this.backdrop), this.button.setAttribute("aria-expanded", "true"), this.cleanup = l(
      this.button,
      this.content,
      () => {
        p(this.button, this.content, {
          placement: this.getAttribute("placement") || "bottom",
          middleware: [
            b(),
            f(),
            m({
              apply: ({ availableWidth: e, availableHeight: s }) => {
                Object.assign(this.content.style, {
                  maxWidth: "",
                  maxHeight: ""
                });
                const h = getComputedStyle(this.content);
                (h.maxWidth === "none" || e < parseInt(h.maxWidth)) && (this.content.style.maxWidth = `${e}px`), (h.maxHeight === "none" || s < parseInt(h.maxHeight)) && (this.content.style.maxHeight = `${s}px`);
              }
            })
          ]
        }).then(({ x: e, y: s, placement: h }) => {
          Object.assign(this.content.style, {
            left: `${e}px`,
            top: `${s}px`
          }), this.content.dataset.placement = h;
        });
      },
      { ancestorScroll: !1 }
    );
    const t = this.content.querySelector("[autofocus]");
    t ? t.focus() : this.content.focus(), this.dispatchEvent(new Event("open"));
  }
  wasClosed() {
    var t;
    this.content.hidden || (this.button.setAttribute("aria-expanded", "false"), (t = this.cleanup) == null || t.call(this), c(this.backdrop).then(() => this.backdrop.hidden = !0), c(this.content).then(() => this.content.hidden = !0), this.dispatchEvent(new Event("close")));
  }
  get backdrop() {
    var t;
    return (t = this.shadowRoot) == null ? void 0 : t.firstElementChild;
  }
  get button() {
    return this.querySelector("button, [role=button]");
  }
  get content() {
    return this.children[1];
  }
}
export {
  C as default
};
